%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Please check our website for the latest version of this script:
%   www.cs.ubc.ca/labs/imager/tr/2010/TheoryOfPlenopticMultiplexing/
%
%   Returns a 2D MURA pattern for a given size. 
%
%   Gordon Wetzstein [wetzste1@cs.ubc.ca]
%   PSM Lab, UBC
%   March 2010
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pattern = mura(p)
    pattern = zeros(p,p);
    for i=0:p-1
        for j=0:p-1                 
            if i == 0 
                pattern(i+1,j+1) = 0;
            elseif j == 0               
                pattern(i+1,j+1) = 1;
            elseif jacobiSymbol(i,p)*jacobiSymbol(j,p) == 1                                        
                pattern(i+1,j+1) = 1;
            else
                pattern(i+1,j+1) = 0;
            end
        end
    end   
end

function result = jacobiSymbol(k,p)         
    result = -1;
    for x=1:p               
        if mod(x^2,p) == mod(k,p)
            result = 1;
            return;
        end
    end
end