%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Please check our website for the latest version of this script:
%   www.cs.ubc.ca/labs/imager/tr/2010/TheoryOfPlenopticMultiplexing/
%
%   Returns a 2D sum-of-sinusoids pattern for a given size. 
%
%   Gordon Wetzstein [wetzste1@cs.ubc.ca]
%   PSM Lab, UBC
%   March 2010
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pattern = sos(p)

    % initialize pattern
    pattern = zeros(p);

    % get grid
    step = 1/p;
    [XX YY] = meshgrid(0:step:1-step, 0:step:1-step);
    
    px = (p-1)/2; py = (p-1)/2;
    for ky=-py:py
        for kx=-px:px
            pattern = pattern + 0.5*cos( 2*pi*ky*YY + 2*pi*kx*XX )+0.5;
        end
    end
    
    % normalize it
    pattern = pattern ./ max(pattern(:));
end