%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Please check our website for the latest version of this script:
%   www.cs.ubc.ca/labs/imager/tr/2010/TheoryOfPlenopticMultiplexing/
%  
%   general spatial reconstruction applied to Shield Fields dataset 
%
%   Thanks to Doug Lanman (mesh.brown.edu/dlanman/) for making his datasets
%   publically available. The Shield Fields website is
%   mesh.brown.edu/dlanman/research/SIGGRAPH Asia 2008/shield_fields.html
%
% (c) Ivo Ihrke
%     University of British Columbia 
%
%  2009-04-20
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all

I=double(imread('mannequin.png'));
I2=double(imread('mask.png'));
I=I(:,:,1);


Ig=double(imread('guideImage.png')) / 255;
%Ig=imresize(Ig,size(I)./4);


%I=(I/255) ./ (I2 / 255);
I=circshift(I,[6 4]);

%dimensions
sx = 128;
sy = 85;

load mura11x11;

num_tiles = 11;
num_tiles_M = 26;

%startx=sx/8;
%starty=sy/8*2;
%ex = (sx/8*3-1);
%ey = (4*sy/8-1);

%startx=1;
%starty=sy/4;
%ex = (sx/2-1);
%ey = (3*sy/4-1);

startx=1;
starty=1;
ex = (sx-1);
ey = (sy-1);



fx = 1/5;
fy = 1/5;

[Xi,Yi] = meshgrid(startx:fx:ex,starty:fy:ey);

Xi = Xi;
Yi = Yi;

%assemble low-res views

offx=( ones(num_tiles_M,1)*(0:(num_tiles_M-1)) ) / num_tiles_M;
offy=( ones(num_tiles_M,1)*(0:(num_tiles_M-1)) )' / num_tiles_M;

Itest=zeros(size(I));
disp('assembling correlated views');
Ic = zeros( sy, sx, size(I,3), num_tiles_M^2 );
for y=1:num_tiles_M
  for x=1:num_tiles_M
    off = (y-1)*num_tiles_M + x; 
    Ic(:,:,:,off) = I(y:num_tiles_M:size(I,1),x:num_tiles_M:size(I,2),:);


    
    Idum=Ic(:,:,1,off);

%    It = (Idum - median(Idum(:))) / ( 8 * std(Idum(:)) ) + 0.5;
%    It(It<0) = 0;
%    It(It>1) = 1;
%     It=histeq(squeeze(Idum/255),255);

 %    subplot(2,1,1);	
  %   imagesc(Idum/255);
   %  subplot(2,1,2);	
    % imagesc(It);
     %drawnow	

%    Itest(y:num_tiles_M:size(I,1),x:num_tiles_M:size(I,2),1) = It; 
%    Idum=Ic(:,:,2,off);
%    Itest(y:num_tiles_M:size(I,1),x:num_tiles_M:size(I,2),2) = Idum/median(Idum(:)); 
%    Idum=Ic(:,:,3,off);
%    Itest(y:num_tiles_M:size(I,1),x:num_tiles_M:size(I,2),3) = Idum/median(Idum(:)); 
  end
end

[a b c] = mkdir('results');
[a b c] = mkdir('channels');

[X,Y] = meshgrid(1:size(Ic,2), 1:size(Ic,1));

disp('upsampling correlated views');

F=fspecial('sobel')';

Ic_up = zeros ( size(Yi,1), size(Yi,2), size(I,3), num_tiles_M^2 );
for y=1:num_tiles_M
  for x=1:num_tiles_M
    for c=1:size(I,3)
      off = (y-1)*num_tiles_M+x;
      disp(sprintf('%d:(%f,%f)',off,offx(y,x),offy(y,x)));
%       Iintermed = interp2 ( X+offx(y,x), Y+offy(y,x), squeeze( Ic( :,:,c,off) ), Xi, Yi,'cubic');

%      Iintermed = joint_bilateral_up ( X+offx(y,x), Y+offy(y,x), squeeze( Ic( :,:,c,off) ), Ig, Xi, Yi);	
%      Iintermed = joint_bilateral_up ( X+offx(y,x), Y+offy(y,x), squeeze( Ic( :,:,c,off) ), Ig, Xi-offx(y,x), Yi-offy(y,x));	
      Iintermed = joint_bilateral_up_cubic_spatial ( X+offx(y,x), Y+offy(y,x), squeeze( Ic( :,:,c,off) ), Ig, Xi-offx(y,x), Yi-offy(y,x));	
%      Iintermed = joint_bilateral_up_cubic_spatial ( X+offx(y,x), Y+offy(y,x), squeeze( Ic( :,:,c,off) ), ones(size(Ig)), Xi, Yi);	
      imshow(Iintermed/max(Iintermed(:)));
      colorbar
      drawnow; 
%      pause
%       Iintermed = medfilt2( Iintermed, [ 5 5 ] );
%       Iintermed = imfilter( Iintermed, F );
       Ic_up(:,:,c,off) = Iintermed; 
    end
    imwrite(squeeze(double(Ic_up(:,:,:,off))/255),sprintf('channels/lf_spatial_cubic_%02d_%02d.png',y,x));	
  end
end


disp('assembling correlation matrix');

%assemble de-correlation matrix
F = zeros( num_tiles_M^2, num_tiles^2 );
S = complex(zeros( num_tiles^2, num_tiles^2 ));
for y=1:num_tiles
  for x=1:num_tiles
    off = (y-1)*num_tiles+x;

    dummy  = zeros(num_tiles_M, num_tiles_M );

    dummy2 = zeros(num_tiles, num_tiles );

    dummys = zeros(num_tiles, num_tiles );

    dummy2(y,x) = 1;
    dummy(8+y,8+x) = 1;

    dummys(y,x) = complex( 1, -1 )/2;
    dummys(num_tiles-y+1,num_tiles-x+1) = complex( 1, 1 )/2;
    

    dummy  = ifft2(ifftshift(dummy));
    dummy2 = ifft2(ifftshift(dummy2));
    Finv( :, off ) = dummy(:); 
    Finv2( :, off ) = dummy2(:); 
    S (:,off)  = dummys(:);
  end
end
% DC peak is real peak
S(floor(num_tiles^2/2)+1,floor(num_tiles^2/2)+1)=1;

%%% real basis 
%%%
%%% numerical problems below
%%%
%%% Finvreal = zeros(size(Finv));
%%% for i=1:floor(num_tiles^2 / 2)
%%%   off = i*2;
%%%   a   = Finv(:,i);
%%%   b   = Finv(:,num_tiles^2-(i-1));
%%% 
%%%   %real part (cos) - symmetric
%%%   Finvreal( :, off - 1 ) = real(a + b)/2;
%%% 
%%%   %imag part (sin) - antisymmetric
%%%   Finvreal( :, off     ) = imag(a - b)/2;
%%% end
%%% Finvreal( :, num_tiles^2) = Finv(:, floor(num_tiles^2 / 2)+1 );
%%% 

%%% stable version: use matrix S
Finvreal = real(Finv * S);
Finvreal2 = real(Finv2 * S);
%%%

F=pinv(Finvreal);
F2=pinv(Finvreal2);

%W = eye(num_tiles^2);
%W(41,41)= 20;

MURA_ft = fftshift(fft2(mura11x11)); 
W=diag( MURA_ft(:) );

PI = F2' * sqrt(W)';
SIGMA = Finv * sqrt(W);

Minv = pinv( PI' ) * pinv ( SIGMA ); 

disp('de-correlating up-sampled views');


% this is the conceptual loop
%Ic_up_dec = zeros( size ( Ic_up ) );
%for x=1:size(Ic_up,2)
%  for y=1:size(Ic_up,1)
%    for c=1:size(I,3)
%      Ic_up_dec( y, x, c, : ) = Minv * squeeze(Ic_up(y,x,c,:));
%    end
%  end
%end

%vectorized implementation
Ic_up_size = size( Ic_up );
Ic_up_size = Ic_up_size(1:3);

Ic_up = reshape ( Ic_up, prod( Ic_up_size ), size(Minv,2) )';

%clear Ic_up;

Ic_up = (Minv * Ic_up);
Ic_up = Ic_up';

Ic_up = reshape( Ic_up, Ic_up_size(1), Ic_up_size(2), ...
		     Ic_up_size(3), size(Minv,1) );



num_tiles_out = sqrt(size(Minv,1));
Iout2=zeros( Ic_up_size(1)*num_tiles_out,  Ic_up_size(1)*num_tiles_out, ...
	     Ic_up_size(3) );
 
for i=0:size(Minv,1)-1

  m=floor(i/num_tiles_out);
  n=mod(i,num_tiles_out);

  Iout = squeeze(real(Ic_up(:,:,:,i+1))/255) * 4;
%  Iout=Iout-min(Iout(:));

  imshow(Iout)
  drawnow

  imwrite(Iout,sprintf('results/lf_spatial_jbfcs_0.01_%02d_%02d.png',m,n));

  sy = Ic_up_size(1);
  sx= Ic_up_size(2);

%  Iout2(((m-1)*sy*3+ 1):m*sy*3,((n-1)*sx*3+1):n*sx*3)=Iout;
  Iout2 ( (m*sy+ 1):(m+1)*sy,(n*sx+1):(n+1)*sx) = Iout;
%  pause(0.1)
end

imwrite(Iout2,'results/spatial_jbfcs_assembled.png');

disp('The reconstruction is saved in the results folder! See results/spatial_jbfcs_assembled.png for the assembled light field.');

