%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Please check our website for the latest version of this script:
%   www.cs.ubc.ca/labs/imager/tr/2010/TheoryOfPlenopticMultiplexing/
%
%   This script processes the original Cones dataset to be used
%   with our reconstruction scripts.
%
%   You need to download the file 'InputCones.png', which is included in 
%   the zipped dataset on
%       http://web.media.mit.edu/~raskar/Mask/MatlabCodeImages.html
%
%   Gordon Wetzstein [wetzste1@cs.ubc.ca]
%   PSM Lab, UBC
%   March 2010
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all;

% load original file
LF = double(imread('InputCones.png')) ./ 255;

% rotate and flip file 
LF = flipdim(imrotate(LF, -90), 2);

% resample image
LFresampled = imresize(LF, [1719 2142], 'bicubic');

% shift
LFresampled = circshift(LFresampled, [0 -3]);

% save file 
imwrite(LFresampled, 'InputCones_9x9.png');


